package com.jiayue.ssi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jiayue.ssi.entity.ForecastPowerShortTerm;
import com.jiayue.ssi.mapper.ForecastPowerShortTermMapper;
import com.jiayue.ssi.service.ForecastPowerShortTermService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import java.util.List;


@Service
@Slf4j
public class ForecastPowerShortTermServiceImpl extends ServiceImpl<ForecastPowerShortTermMapper, ForecastPowerShortTerm> implements ForecastPowerShortTermService {
  @Autowired
  ForecastPowerShortTermMapper forecastPowerShortTermMapper;

  /**
   * 按时间段删除数据
   *
   * @param startTime
   * @param endTime
   * @param listDq
   */
  @Transactional(propagation = Propagation.REQUIRED)
  @Override
  public void deleteBetweenAndGenTime(Long startTime, Long endTime, List<ForecastPowerShortTerm> listDq) {
    QueryWrapper wrapper = new QueryWrapper<>();
    wrapper.ge("forecast_time",startTime);
    wrapper.le("forecast_time",endTime);
    this.remove(wrapper);
    //保存短期数据
    this.saveBatch(listDq);
  }

}
